# Auto Research Note Example

## Table of Contents

Table of Contents(TOC)는 해당 마크다운에 등장하는 모든 헤더의 참조를 달아서 리스트로 정리한 것을 말한다. 여기서는 단순히 `!TOC`를 이용해 구현할 수 있다.

  - [Auto Research Note Example](#auto-research-note-example)  
    - [Table of Contents](#table-of-contents)  
    - [Math test](#math-test)  
    - [Cell with no caption will be ignored](#cell-with-no-caption-will-be-ignored)  
    - [Every hearder will be recorded by nbresnote](#every-hearder-will-be-recorded-by-nbresnote)  
      - [H3 header](#h3-header)  
      - [Second H3 header](#second-h3-header)  
    - [Figure capture](#figure-capture)  
    - [Code and Cell capture](#code-and-cell-capture)  
      - [Code](#code)  
      - [Cell](#cell)  
    - [Table capture](#table-capture)  
    - [Refer content](#refer-content)  
    - [Daily note](#daily-note)  
    - [마치며](#마치며)  


## Math test

$`a^2+b^2 =c^2`$


```math
 
multi line math
\int ^ \infty _{-\infty} xdx

```

## Cell with no caption will be ignored

`nbresnote`는 기본적으로 모든 코드 셀을 무시한다. 오직 마크다운 셀만이 남겨진다.

## Every hearder will be recorded by `nbresnote`

### H3 header

### Second H3 header 

## Figure capture

연구노트에는 그림만 이용하여 표현하는것이 편리하다.  
기본적으로 모든 셀을 무시하기 때문에 특정 그림을 남기고 싶다면 *해당 셀 밑*에 마크다운셀을 만들고 다음과 같이 입력하면 된다.  
```
!figure <Figure caption here>
```

![fig. 1](example/fig1.png)  
**Fig. 1.** Figure caption here  
<br>


Not Implemented yet :
>if you want reference, `--ref=` will capture the title of figure

![fig. 2](example/fig2.png)  
**Fig. 2.** Reverse plot  
<br>


## Code and Cell capture

연구노트에 코드 혹은 셀(결과 포함)을 첨부하고 싶을 수 있다. 그런 경우 *해당 셀의 위*에 마크다운 셀을 만들고 `!code` 혹은 `!cell`을 이용해 코드를 노트할수 있다.

### Code

**Code 1.** : code caption here  


```python
import numpy as np
np.arange(5)
```

<br>
<br>


### Cell

**Code 2.** : cell caption here  


---

```python
for i in range(10):
    print(i)
```

*Outputs :*  


    0
    1
    2
    3
    4
    5
    6
    7
    8
    9



---


<br>
<br>


**Code 3.** : cell with figure  


---

```python
plt.plot(np.sin(np.linspace(0,4*np.pi,100)))
```

*Outputs :*  


    [<matplotlib.lines.Line2D at 0x2b3b21810210>]

![png](example/outputs3_0.png)

    <Figure size 432x288 with 1 Axes>


---


<br>
<br>


code 는 단순히 코드만을 cell은 코드와 결과를 모두 저장한다.

## Table capture

Python을 이용해 데이터를 분석하다 보면 자연스럽게 `Pandas` 의 `DataFrame`을 이용하게 된다.

코드보다 `DataFrame`의 표를 넣고 싶은 경우 해당 셀의 아래에 markdown cell을 만들고 `!table <caption>` 이라고 입력해주면 된다.

<div>
<style scoped>
    .dataframe tbody tr th:only-of-type {
        vertical-align: middle;
    }
    .dataframe tbody tr th {
        vertical-align: top;
    }
    .dataframe thead th {
        text-align: right;
    }
</style>
<table border="1" class="dataframe">
  <thead>
    <tr style="text-align: right;">
      <th></th>
      <th>Library</th>
      <th>Version</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>0</th>
      <td>Pandas</td>
      <td>1.3.1</td>
    </tr>
    <tr>
      <th>1</th>
      <td>Numpy</td>
      <td>1.20.3</td>
    </tr>
  </tbody>
</table>
</div>


**Table 1** Pandas와 Numpy 버전 비교  
<br><br>


## Refer content

특정 그림이나 테이블을 참조해서 이야기한다고 해보자 여기서는 `--ref=reverse` 로 되어있는 그림을 참조하려면 중괄호({)를 두 번 이용하여 참조할 수 있다.

>ex) 그림 2를 보면,

## Daily note

일일 연구노트 작성을 위해 어떤 헤더가 추가되었는지를 `daily/daily.md`에 지속적으로 업데이트 한다. 따라서 연구일지를 따로 작성할 필요없이 `daily.md` 파일을 수정함으로써 연구일지를 자동으로 작성할 수 있다.

![데일리노트](daily/daily.md)

## 마치며

이외에 혹시 문의사항이나 건의가 있다면 알려주기 바람. (jhjung@uos.ac.kr)